<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/paper-button/paper-button.html">
<link rel="import" href="/extern/bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="/extern/bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="/extern/bower_components/paper-spinner/paper-spinner.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/ts/ajaxell/html/elements/ajaxell-icons/ajaxell-icons.html">
<link rel="import" href="/extern/bower_components/iron-icon/iron-icon.html">
<link rel="import" href="/extern/bower_components/iron-icons/iron-icons.html">

<link rel="import" href="/ts/common-elements/auto-update/auto-update.html">
<link rel="import" href="/ts/common-elements/ts-ajax/ts-ajax.html">
<link rel="import" href="/ts/common-elements/command-input/command-input.html">

<!--
`ts-operations` is the polymer element of the operations panel

Example:

    <ts-operations></ts-operations>

-->

<dom-module id="ts-operations">
  <template>
    <style>
:host{display:block}command-input{min-width:170px;margin:5px;display:block}auto-update{display:inline-block;margin:5px 0;margin-bottom:1em}paper-button[command="reset"]{background-color:var(--paper-deep-orange-500, red)}iron-icon{height:48px;width:48px}paper-dialog{overflow:auto}section[results]{border-top:1px dashed #E0E0E0;padding-top:1em}section[inputs]{padding-right:15px;padding-left:10px;padding-top:8px;border-right:1px dashed #E0E0E0;max-width:400px}section[state] p{margin:10px 0;padding-left:4px;font-size:2em}section[state] p span[status]{font-weight:bold;text-transform:uppercase}section[state] p paper-spinner{font-size:0}section[commands]{padding-top:1em;padding-bottom:1em;border-top:1px dashed #E0E0E0}[horizontal][layout] [flex]>section{padding-left:1em}#result{white-space:pre-wrap}#result [result-type="busy"]{color:var(--paper-grey-500, gray)}#result [result-type="info"]{color:var(--paper-blue-800, blue)}#result [result-type="warning"]{color:var(--paper-orange-800, orange)}#result [result-type="error"]{color:var(--paper-red-800, red)}

</style>
    <style include="reset-css"></style>
    <style include="iron-flex-layout-attributes"></style>

    <section horizontal layout>
      <section inputs>
        <ts-ajax id="ajax_inputs" data="{{_inputs}}" callback="getInputs" handle-as="json" auto></ts-ajax>
        <template is="dom-repeat" items="{{_inputs}}" as="input" sort="_sortInput">
          <command-input name=[[input.name]] type=[[input.type]] value={{input.value}} always-float-label></command-input>
        </template>
      </section>
      <section flex>
        <section state>
          <p>
            <span status>[[_displayStatus]]</span>
            <template is="dom-if" if="[[_inTransition]]">
              <span>in progress</span>
            </template>
            <paper-icon-button icon="ajaxell:operations" on-click="_getSVG"></paper-icon-button>
            <paper-spinner active="[[_inTransition]]"></paper-spinner>
          </p>
          <ts-ajax id="ajax_svg" data="{{_svg}}" callback="getGraph" handle-as="text" interval="0"></ts-ajax>
          <paper-dialog id="svg">
          </paper-dialog>
        </section>
        <section commands>
          <template is="dom-repeat" items="[[commands]]" as="command">
            <paper-button raised on-click="_execute" command$="[[command]]">[[command]]</paper-button>
          </template>
          <paper-button raised on-click="_execute" command="reset">reset</paper-button>
          <ts-ajax id="ajax_commands" data="{{commands}}" callback="getCommands" handle-as="json"></ts-ajax>
        </section>

        <section results>
          <auto-update id="update_result"
                       data="{{_result}}"
                       callback="getResult"
                       handle-as="json"
                       interval="7000"
                       no-slider></auto-update>
          <ts-ajax id="ajax_status" data="{{_status}}" callback="getStatus" handle-as="text" on-response="_newStatus"></ts-ajax>
          <div id="result" flex></div>
        </section>
      </section>
    </section>

    <ts-ajax id="execute"
             callback="execute"
             handle-as="json"></ts-ajax>

  </template>
  <script>
Polymer({is:"ts-operations",properties:{_svg:{type:String,observer:"_setSVG"},_result:{type:Object,observer:"_resultChanged"},_inputs:{type:Array},_status:{type:String,observer:"_statusChanged"},_displayStatus:String,_userInterval:{type:Number,value:7e3},_inTransition:{type:Boolean,value:!1,observer:"_inTransitionChanged"}},_sortInput:function(a,b){var ba=this._isBoolean(a),bb=this._isBoolean(b);return ba&&!bb?-1:!ba&&bb?1:0},_getSVG:function(){this.$.svg.open(),this.$.ajax_svg.generateRequest()},_setSVG:function(){Polymer.dom(this.$.svg).innerHTML=this._svg},_isBoolean:function(item){return"boolean"==item.type.toLowerCase()||"bool"==item.type.toLowerCase()},_execute:function(e){var ajax=this.$.execute;if(this._doingReset=!e.model,this._doingReset&&(this._displayStatus="reset"),ajax.splice("parameters",0,ajax.parameters.length),ajax.push("parameters","_eventType_","command"),ajax._eventType_="OnSubmit",ajax.command=this._doingReset?"reset":e.model.command,this._inputs)for(var i=0;i<this._inputs.length;i++){var currentParameter=this._inputs[i];ajax.push("parameters",currentParameter.name),ajax[currentParameter.name]=currentParameter.value}ajax.generateRequest(),this._inTransition=!0},_inTransitionChanged:function(inTransition){!this._inTransition||this._doingReset?this.$.update_result.set("interval",this._userInterval):(this._userInterval=this.$.update_result.interval,this.$.update_result.set("interval",1e3))},_newStatus:function(event,request){var status=request.response;this._inTransition=status.indexOf("_")>-1,this._inTransition?this._displayStatus=status.split("_")[1]:this._displayStatus=status},_statusChanged:function(status){var inTransition=status.indexOf("_")>-1;inTransition||this.$.ajax_inputs.generateRequest()},_encodeParams:function(params){var result="";for(var key in params)""!=result&&(result+="&"),result+=key+"="+encodeURIComponent(params[key]);return result},_resultChanged:function(newval,oldval){if(this.$.ajax_commands.generateRequest(),this.$.ajax_status.generateRequest(),"undefined"!=typeof oldval){var container=Polymer.dom(this.$.result);container.innerHTML="";for(var i=0;i<newval.length;i++){var response=newval[i],resultbox=document.createElement("div");resultbox.setAttribute("result-type",response.type),resultbox.innerHTML=response.value,container.appendChild(resultbox)}}}});
</script>
</dom-module>
